library(data.table)
library(tidyr)
library(dplyr)
library(gtools)
library(stringr)
library(magrittr)
titel <- "Intrinsic (practical) brightness of yFPs"
ondertitel1 <- 'Grown on glucose' #ondertitel 1
ondertitel2 <- 'W303-1A, Grown on glucose'                   #ondertitel2: wat moet er nog na de tekst "x samples" komen?
TextatXaxis <- ""   #which label should the X axis have?
TextatYaxix <- "interest FP : control FP \n fluorescence ratio" #which label should the y axis have?


wd <<- choose.dir()     #set input folder
setwd(wd)              #set input folder
filelist = list.files(pattern = "Results.*.txt")       #make a list with all the txtfiles in a folder

#import data 
datalist = lapply(filelist, function(x)read.table(x, sep="\t", header=T)) 
combined = do.call("smartbind", datalist) 

#get only the yFPs and their non codon-optimized variants
library(dplyr)
combined <- (
  combined %>%
    group_by(Naam2) %>%
    filter(any(Naam2 == c("mTq2", "ymTq2", "ymNeongreen (as GFP)", "mNeongreen (as GFP)", "ymNeongreen (as YFP)", "mNeongreen (as YFP)", "tdTomato", "ytdtomato", "YPET", "ymYPET",  "mScarletI", "ymScarletI", "mVenus", "ymVenus"))))

require(data.table)
require(dplyr)
detach(package:plyr)
library(dplyr)
library(plotrix)
#add sample size per condition
combined <-
  combined %>% 
  group_by(uniqueID) %>% 
  mutate(FP_samplesize=paste(Naam2,", n=",length(uniqueID))) %>% 
  ungroup()
combined$FP_samplesize <- gsub(" ", "", combined$FP_samplesize)
combined$FP_samplesize <- gsub(",n", ", n", combined$FP_samplesize)
combined$FP_samplesize <- gsub("mNeongreen", "mNeongreen ", combined$FP_samplesize)
combined$FP_samplesize <- gsub("as", "as  ", combined$FP_samplesize)
combined$FP_samplesize <- gsub("ymYPET", "zymYPET", combined$FP_samplesize)


# add spectral class and FP name family
combined <-
  combined %>% 
  mutate(FP_group = case_when(uniqueID == "yemVenus-T2A-mTq2" ~ "mVenus",
                              uniqueID == "ymNeongreen-T2A-mCherry" ~ "mNeongreen (as GFP)", 
                              uniqueID == "ymNeongreen-T2A-mtq2" ~ "mNeongreen (as YFP)",
                              uniqueID == "ymScarletI-T2A-mTq2" ~ "mScarletI",
                              uniqueID == "mNeongreen-T2A-mTq2" ~ "mNeongreen (as YFP)", 
                              uniqueID == "ytdtomato-T2A-mTq2" ~ "tdTomato", 
                              uniqueID == "ymYPET-T2A-mtq2" ~ "(m)YPET", 
                              uniqueID == "tdTomato-T2A-mTq2" ~ "tdTomato", 
                              uniqueID == "ymTq2-T2A-mCherry" ~ "mTq2", 
                              uniqueID == "mNeongreen-T2A-mCherry" ~ "mNeongreen (as GFP)", 
                              uniqueID == "yeVenus-T2A-mTq2" ~ "mVenus",
                              uniqueID == "mVenus-T2A-mTq2" ~ "mVenus",
                              uniqueID == "mNeongreen (as YFP)" ~ "mNeongreen (as YFP)", 
                              uniqueID == "YPET-T2A-mTq2" ~ "(m)YPET", 
                              uniqueID == "mScarletI-T2A-mTq2" ~ "mScarletI", 
                              uniqueID == "mTq2-T2A-mcherry" ~ "mTq2", 
                              uniqueID == "mNeongreen (as GFP)" ~ "mNeongreen (as GFP)"))

# get expression levels by comparing the amount of fluorescence of the control FP, and correct for exposure differences
combined <-
  combined %>% 
  mutate(Expression_controlFP = case_when(uniqueID == "yemVenus-T2A-mTq2" & day_replicate == "1"  ~ (Channel4)/200,
         uniqueID == "ymNeongreen-T2A-mCherry" & day_replicate == "1"  ~ (Channel1)/200 ,
         uniqueID == "ymNeongreen-T2A-mtq2" & day_replicate == "1"  ~ (Channel4)/200,
         uniqueID == "ymScarletI-T2A-mTq2" & day_replicate == "1"  ~ (Channel4)/200,
         uniqueID == "mNeongreen-T2A-mTq2" & day_replicate == "1"  ~ (Channel4)/200,
         uniqueID == "ytdtomato-T2A-mTq2" & day_replicate == "1"  ~ (Channel4)/200,
         uniqueID == "ymYPET-T2A-mtq2" & day_replicate == "1"  ~ (Channel4)/200,
         uniqueID == "tdTomato-T2A-mTq2" & day_replicate == "1"  ~ (Channel2)/200,
         uniqueID == "ymTq2-T2A-mCherry" & day_replicate == "1"  ~ (Channel1)/200,
         uniqueID == "mNeongreen-T2A-mCherry" & day_replicate == "1"  ~ (Channel3)/1500,
         uniqueID == "mVenus-T2A-mTq2" & day_replicate == "1"  ~ (Channel2)/200,
         uniqueID == "mNeongreen (as YFP)" & day_replicate == "1"  ~ (Channel2)/200,
         uniqueID == "YPET-T2A-mTq2" & day_replicate == "1"  ~ (Channel2)/1500,
         uniqueID == "mScarletI-T2A-mTq2" & day_replicate == "1"  ~ (Channel2)/200,
         uniqueID == "mTq2-T2A-mcherry" & day_replicate == "1"  ~ (Channel3)/1500, 
         uniqueID == "mNeongreen-T2A-mCherry" & day_replicate == "1"  ~ (Channel3)/1500, 
uniqueID == "yemVenus-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/500,
uniqueID == "ymNeongreen-T2A-mCherry" & day_replicate == "2"  ~ (Channel1)/200,
uniqueID == "ymNeongreen-T2A-mtq2" & day_replicate == "2"  ~ (Channel2)/200,
uniqueID == "ymScarletI-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/200,
uniqueID == "mNeongreen-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/2000,
uniqueID == "ytdtomato-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/200,
uniqueID == "ymYPET-T2A-mtq2" & day_replicate == "2"  ~ (Channel2)/200,
uniqueID == "tdTomato-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/2000,
uniqueID == "ymTq2-T2A-mCherry" & day_replicate == "2"  ~ (Channel1)/200,
uniqueID == "mNeongreen-T2A-mCherry" & day_replicate == "2"  ~ (Channel1)/2000,
uniqueID == "mVenus-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/2000,
uniqueID == "mNeongreen (as YFP)" & day_replicate == "2"  ~ (Channel2)/2000,
uniqueID == "YPET-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/2000,
uniqueID == "mScarletI-T2A-mTq2" & day_replicate == "2"  ~ (Channel2)/2000,
uniqueID == "mTq2-T2A-mcherry" & day_replicate == "2"  ~ (Channel2)/2000, 
uniqueID == "mNeongreen-T2A-mCherry" & day_replicate == "2"  ~ (Channel1)/2000, 
uniqueID == "ymNeongreen-T2A-mCherry" & day_replicate == "3"  ~ (Channel3)/200,
uniqueID == "ymNeongreen-T2A-mtq2" & day_replicate == "3"  ~ (Channel2)/200,
uniqueID == "ymScarletI-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/200,
uniqueID == "mNeongreen-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/2000,
uniqueID == "ytdtomato-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/200,
uniqueID == "ymYPET-T2A-mtq2" & day_replicate == "3"  ~ (Channel2)/200,
uniqueID == "tdTomato-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/2000,
uniqueID == "ymTq2-T2A-mCherry" & day_replicate == "3"  ~ (Channel3)/200,
uniqueID == "mNeongreen-T2A-mCherry" & day_replicate == "3"  ~ (Channel3)/2000,
uniqueID == "mVenus-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/2000,
uniqueID == "mNeongreen (as YFP)" & day_replicate == "3"  ~ (Channel2)/2000,
uniqueID == "YPET-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/2000,
uniqueID == "mScarletI-T2A-mTq2" & day_replicate == "3"  ~ (Channel2)/2000,
uniqueID == "mTq2-T2A-mcherry" & day_replicate == "3"  ~ (Channel3)/2000, 
uniqueID == "mNeongreen-T2A-mCherry" & day_replicate == "3"  ~ (Channel3)/2000))
         
         



#calculate coefficient of variation
errordata <- combined %>% 
  group_by(uniqueID) %>% 
  select(ratio) %>% 
  summarise_all(funs(mean,sd)) %>% 
  mutate (relative_sd=sd/mean)

# function for plotting 0.05-0.95 datapoints in boxplot
boxstats <- function(x) {
  r <- quantile(x, probs = c(0.05, 0.25, 0.5, 0.75, 0.95))
  names(r) <- c("ymin", "lower", "middle", "upper", "ymax")
  r
}


# one-way anova
# We want to know if there is any significant difference between the different groups
res.aov <- aov(ratio ~ FP_samplesize, data = combined)
summary(res.aov) #The groups highlighted with "*" in the model summary have significant differences
# Tukey HSD (Tukey Honest Significant Differences, R function: TukeyHSD()) for performing multiple pairwise-comparison between the means of groups
TukeyHSD(res.aov)

# one-way anova
# We want to know if there is any significant difference between the different groups
res.aov <- aov(Expression_controlFP ~ FP_samplesize, data = combined)
summary(res.aov) #The groups highlighted with "*" in the model summary have significant differences
# Tukey HSD (Tukey Honest Significant Differences, R function: TukeyHSD()) for performing multiple pairwise-comparison between the means of groups
TukeyHSD(res.aov)

library(ggplot2)
library(ggpmisc)
library(gridBase)
library(grid)
library(ggsignif)
plot <- ggplot(combined, aes(y=ratio, x=FP_samplesize, fill=FP_samplesize))  +   geom_jitter(alpha=0.12, width=0.15) + stat_summary(fun.data = boxstats, geom = "boxplot", alpha=0.75,  position=position_dodge(width=0.98), lwd=0.8, fatten=1)  +   theme_bw() + labs(title = titel, subtitle = ondertitel2)+ theme(plot.title = element_text(hjust = 0.5), plot.subtitle = element_text(hjust = 0.5)) +  labs(x=TextatXaxis,y=TextatYaxix)  + theme(legend.position="none")
plot
plot2 <- plot + facet_grid(FP_group~., scales = "free", space = "free") + coord_flip(ylim = c(0, 6)) +  theme(strip.background = element_rect(fill="transparent", color="transparent")) + theme( strip.text.x = element_text(size = 16),
                                                                                                                                                                                                 strip.text = element_text(size=16),
                                                                                                                                                                                                 axis.text = element_text( size = 15 ),
                                                                                                                                                                                                 axis.text.x = element_text( size = 15 ),
                                                                                                                                                                                                 axis.text.y = element_text( size = 13 ),
                                                                                                                                                                                                 axis.title = element_text( size = 15),
                                                                                                                                                                                                 plot.title = element_text(size=24),
                                                                                                                                                                                                 plot.subtitle = element_text(size=18),
                                                                                                                                                                                                 legend.position="none") 
plot2


plot3 <- ggplot(combined, aes(y=Expression_controlFP, x=FP_samplesize, fill=FP_samplesize)) +   geom_jitter(alpha=0.12, width=0.15) + stat_summary(fun.data = boxstats, geom = "boxplot", alpha=0.75,  position=position_dodge(width=0.98), lwd=0.8, fatten=1)  +   theme_bw() + labs(title = "Expression levels", subtitle = ondertitel2)+ theme(plot.title = element_text(hjust = 0.5), plot.subtitle = element_text(hjust = 0.5)) +  labs(x=TextatXaxis,y="Expression of the control FP")  + theme(legend.position="none")
plot3
plot4 <- plot3 + facet_grid(FP_group~., scales = "free", space = "free") + coord_flip(ylim = c(0, 18))  +  theme(strip.background = element_rect(fill="transparent", color="transparent")) + theme( strip.text.x = element_text(size = 16),
                                                                                                                                                                                    strip.text = element_text(size=16),
                                                                                                                                                                                    axis.text = element_text( size = 15 ),
                                                                                                                                                                                    axis.text.x = element_text( size = 15 ),
                                                                                                                                                                                    axis.text.y = element_text( size = 13 ),
                                                                                                                                                                                    axis.title = element_text( size = 15),
                                                                                                                                                                                    plot.title = element_text(size=24),
                                                                                                                                                                                    plot.subtitle = element_text(size=18),
                                                                                                                                                                                    legend.position="none") 
plot4



    